LeetCode 278 First Bad Version(第一个坏版本)(二分法)(*)

来源:互联网 发布:early stopping算法 编辑:程序博客网 时间:2024/06/08 10:42

翻译

你是一个产品经理,目前正在带领团队去开发一个新产品。不幸的是,产品的上一个版本没有通过质量检测。因为每个版本都是建立在前一个版本基础上开发的,所以坏版本之后的版本也都是坏的。假设你有n个版本[1,2,...,n],并且你想找出造成后面所有版本都变坏的第一个坏版本。给你一个API——bool isBadVersion(version),它能够确定一个版本是否是坏的。实现一个函数去找出第一个坏版本。你应该尽可能少地去调用这个API。

原文

You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one, which causes all the following ones to be bad.You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.

分析

其实题目说了这么多,解出来只需要用二分法就够了,只不过中间挺容易出错的。

// Forward declaration of isBadVersion API.bool isBadVersion(int version);class Solution {public:    int firstBadVersion(int n) {        int l = 0, r = n;        while (l < r) {            int mid = l + (r - l) / 2;            if (isBadVersion(mid))                r = mid;            else                l = mid + 1;        }        return l;    }};

今天写的第六道题了,好累哎……

1 0